stages:
  - Static Analysis
  - Release
  - Deploy

flake8:
  stage: Static Analysis
  image: python:3.10-slim
  before_script:
    - python -V
    - python -m pip install flake8
  script:
    - flake8 src | tee flake8_report.txt
  artifacts:
    when: on_failure
    paths:
      - flake8_report.txt
pylint:
  stage: Static Analysis
  image: python:3.10-slim
  before_script:
    - python -V
    - python -m pip install -r requirements.txt
    - python -m pip install pylint
  script:
    - pylint -d C0103,E1101 --fail-under=7 src | tee pylint_report.txt
  artifacts:
    when: always
    paths:
      - pylint_report.txt


release-image:
  stage: Release
  image: docker:20.10.11
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:latest" -t "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:$CI_COMMIT_SHA" .
    - docker push "$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH" --all-tags

deploy-ecs:
  stage: Deploy
  image: 'registry.gitlab.com/gitlab-org/cloud-deploy/aws-ecs:latest'
  environment:
    name: production-ecs
  rules:
    - if: '$CI_COMMIT_REF_NAME == "master"'
  script:
    - aws ecs list-services --cluster cs302-labs
    - ecs update-task-definition
